// Generated by CoffeeScript 2.7.0
(function() {
  var _, extractValue, parseExpr, types;

  _ = require('lodash');

  ({parseExpr, extractValue} = require('./util'));

  types = require('./types');

  module.exports = function({types}) {
    return function(name) {
      var exposed, meta;
      meta = {
        name: name,
        required: false,
        valueType: types.string
      };
      exposed = {
        required: function() {
          meta.required = true;
          return exposed;
        },
        ns: function(ns) {
          meta.ns = ns;
          return exposed;
        },
        bind: function(...opts) {
          meta.bind = parseExpr(...opts);
          return exposed;
        },
        value: function(value) {
          meta.value = value;
          meta.required = true;
          return exposed;
        },
        sample: function(value) {
          meta.sample = value;
          return exposed;
        },
        generate: function(obj, elem) {
          var value;
          value = extractValue(meta, obj);
          if (value != null) {
            if (meta.ns != null) {
              return elem.setAttributeNS(meta.ns, meta.name, value);
            } else {
              return elem.setAttribute(meta.name, value);
            }
          }
        },
        extract: function(elem, target, raw) {
          var decoded, value;
          if (meta.bind != null) {
            value = meta.ns != null ? elem.getAttributeNS(meta.ns, meta.name) : elem.getAttribute(meta.name);
            decoded = raw ? value : meta.valueType.from(value);
            if (value != null) {
              return meta.bind.set(target, decoded);
            }
          }
        },
        descriptor: function() {
          var ref;
          return (ref = meta.bind) != null ? ref.descriptor(_.merge({}, meta.valueType.desc, {
            sample: meta.sample != null ? meta.valueType.from(meta.sample) : void 0
          })) : void 0;
        },
        isSet: function(obj) {
          return !meta.bind || (meta.bind.get(obj) != null);
        },
        definedOn: function(elem) {
          if (meta.ns != null) {
            return elem.hasAttributeNS(meta.name) && ((meta.bind != null) || elem.getAttributeNS(meta.name) === meta.value);
          } else {
            return elem.hasAttribute(meta.name) && ((meta.bind != null) || elem.getAttribute(meta.name) === meta.value);
          }
        },
        relaxng: function(ctx) {
          var data, nested;
          data = meta.value != null ? ctx.element('value').content(ctx.text().value(meta.value)) : meta.valueType.relaxng(ctx);
          nested = ctx.element('attribute').attrs(ctx.attr('name').value(meta.name)).content(data);
          if (meta.required) {
            return nested;
          } else {
            return ctx.element('optional').content(nested);
          }
        }
      };
      _.forEach(types, function(value, key) {
        return exposed[key] = function() {
          meta.valueType = value;
          return exposed;
        };
      });
      return exposed;
    };
  };

}).call(this);
