// Generated by CoffeeScript 2.7.0
(function() {
  var DOMParser, _, binding, curlyNS, forAllAttributes;

  DOMParser = require('@xmldom/xmldom').DOMParser;

  _ = require('lodash');

  binding = require('./binding');

  curlyNS = 'https://github.com/wspringer/cruftless';

  forAllAttributes = function(node, fn) {
    var i, length, result;
    i = 0;
    length = node.attributes.length;
    result = [];
    while (i <= length - 1) {
      result.push(fn(node.attributes[i]));
      i += 1;
    }
    return result;
  };

  module.exports = function(opts) {
    var attr, comment, element, parse, text;
    ({element, attr, text, comment} = opts);
    parse = function(node) {
      var attrs, childNodes, content, el, empty, piNode;
      switch (node.nodeType) {
        case 1:
          el = element(node.tagName);
          if (node.namespaceURI) {
            el.ns(node.namespaceURI);
          }
          childNodes = Array.from(node.childNodes);
          piNode = childNodes.find(function(node) {
            return node.nodeType === 7;
          });
          if ((piNode != null) && piNode.target === 'bind') {
            binding.raw(piNode.data).apply(el);
          }
          // commentNode = childNodes.find (node) -> node.nodeType is 8
          // if commentNode?
          //   binding.raw(commentNode.textContent).apply(el)
          content = childNodes.map(parse).filter(_.negate(_.isUndefined));
          el.content(...content);
          attrs = [];
          forAllAttributes(node, function(item) {
            var res;
            if ((item.namespaceURI === curlyNS && item.localName === 'bind') || (item.name === 'c-bind')) {
              return binding.raw(item.value).apply(el);
            } else if ((item.namespaceURI === curlyNS && item.localName === 'if') || (item.name === 'c-if')) {
              return binding.raw(item.value).apply(el, 'if');
            } else if (item.prefix === 'xmlns') {

            } else {
              res = binding.curly(item.value).apply(attr(item.name));
              if (item.namespaceURI) {
                res.ns(item.namespaceURI);
              }
              return attrs.push(res);
            }
          });
          el.attrs(...attrs);
          return el;
        case 3:
          empty = /^\s*$/.test(node.textContent);
          if (!empty) {
            return binding.curly(node.textContent).apply(text());
          }
          break;
        case 4:
          empty = /^\s*$/.test(node.textContent);
          if (!empty) {
            return binding.curly(node.data).apply(text());
          }
          break;
        case 8:
          empty = /^\s*$/.test(node.textContent);
          if (!empty) {
            return binding.curly(node.textContent).apply(comment());
          }
      }
    };
    return function(xml) {
      return parse(new DOMParser().parseFromString(xml).documentElement);
    };
  };

}).call(this);
