// Generated by CoffeeScript 2.7.0
(function() {
  var _, di, identity, parseExpr, parser, serializer;

  serializer = new ((require('@xmldom/xmldom').XMLSerializer))();

  di = new ((require('@xmldom/xmldom').DOMImplementation))();

  parser = new ((require('@xmldom/xmldom').DOMParser))();

  _ = require('lodash');

  ({identity} = require('lodash'));

  ({parseExpr} = require('./util'));

  module.exports = function({types, format = _.identity}) {
    return function(name) {
      var exposed, meta;
      meta = {
        name: name,
        attrs: [],
        content: [],
        required: true,
        multiple: false,
        scope: function(target) {
          return target || {};
        },
        traverse: function(obj, iterator) {
          return iterator(obj);
        },
        descriptor: function() {
          var concatenated, ref;
          concatenated = _.concat((ref = meta.if) != null ? ref.descriptor() : void 0, meta.attrs.map(function(item) {
            return item.descriptor();
          }), meta.content.map(function(item) {
            return item.descriptor();
          }));
          return _.merge(..._.reject(concatenated, _.isUndefined));
        }
      };
      exposed = {
        optional: function() {
          meta.required = false;
          return exposed;
        },
        attrs: function(...attr) {
          meta.attrs.push(...attr);
          return exposed;
        },
        content: function(...elem) {
          meta.content.push(...elem);
          return exposed;
        },
        isRequired: function() {
          return meta.required;
        },
        ns: function(ns) {
          if (ns != null) {
            meta.ns = ns;
          }
          return exposed;
        },
        bind: function(...opts) {
          meta.bind = parseExpr(...opts);
          return exposed.object();
        },
        if: function(...opts) {
          meta.if = parseExpr(...opts);
          return exposed;
        },
        array: function() {
          meta.multiple = true;
          meta.scope = function(target) {
            var coll, scope;
            coll = meta.bind.get(target);
            if (coll != null) {
              if (Array.isArray(coll)) {
                scope = {};
                coll.push(scope);
                return scope;
              } else {
                throw new Error(`Scope already assignd value of type ${typeof value}`);
              }
            } else {
              coll = [];
              meta.bind.set(target, coll);
              scope = {};
              coll.push(scope);
              return scope;
            }
          };
          meta.traverse = function(obj, iterator) {
            var coll;
            coll = meta.bind.get(obj) || [];
            return coll.forEach(iterator);
          };
          meta.descriptor = function() {
            var concatenated, ref, result;
            concatenated = _.concat((ref = meta.if) != null ? ref.descriptor() : void 0, meta.attrs.map(function(item) {
              return item.descriptor();
            }), meta.content.map(function(item) {
              return item.descriptor();
            }));
            result = {
              type: 'array',
              element: _.merge(..._.reject(concatenated, _.isUndefined))
            };
            if (meta.bind != null) {
              return meta.bind.descriptor(result);
            } else {
              return result;
            }
          };
          return exposed;
        },
        object: function() {
          meta.scope = function(target) {
            var scope;
            scope = meta.bind.get(target);
            if (scope != null) {
              if (typeof value === 'object') {
                return value;
              } else {
                throw new Error(`Scope already assignd value of type ${typeof value}`);
              }
            } else {
              scope = {};
              meta.bind.set(target, scope);
              return scope;
            }
          };
          meta.traverse = function(obj, iterator) {
            return iterator(meta.bind.get(obj));
          };
          meta.descriptor = function() {
            var merged, ref;
            merged = _.merge(..._.reject(_.concat((ref = meta.if) != null ? ref.descriptor() : void 0, meta.attrs.map(function(item) {
              return item.descriptor();
            }), meta.content.map(function(item) {
              return item.descriptor();
            })), _.isUndefined));
            if (meta.bind != null) {
              return meta.bind.descriptor(merged);
            } else {
              return merged;
            }
          };
          return exposed;
        },
        generate: function(obj, context) {
          var doc;
          doc = (context != null ? context.ownerDocument : void 0) || di.createDocument();
          return meta.traverse(obj, function(item) {
            var el;
            if (!(meta.if != null) || (meta.if.get(item) != null)) {
              el = meta.ns != null ? doc.createElementNS(meta.ns, meta.name) : doc.createElement(meta.name);
              meta.attrs.forEach(function(attr) {
                return attr.generate(item, el);
              });
              meta.content.forEach(function(node) {
                if (node.isSet(item)) {
                  return node.generate(item, el);
                }
              });
              if (context != null) {
                context.appendChild(el);
              } else {
                return el;
              }
            }
          });
        },
        isSet: function(obj) {
          var checked;
          return (_.isEmpty(meta.attrs) && _.isEmpty(meta.content)) || (checked = false, meta.traverse(obj, function(item) {
            return checked = checked || _.some(meta.attrs.concat(meta.content), function(x) {
              return x.isSet(item);
            });
          }), checked);
        },
        toDOM: function(obj) {
          return exposed.generate(obj);
        },
        toXML: function(obj) {
          return format(serializer.serializeToString(exposed.generate(obj)));
        },
        matches: function(elem) {
          return elem.nodeType === 1 && elem.localName === meta.name && (!(meta.ns != null) || meta.ns === elem.namespaceURI) && (elem.attributes.length === meta.attrs.length) && _.every(meta.attrs, function(attr) {
            return attr.definedOn(elem);
          });
        },
        extract: function(elem, target = {}, raw = false) {
          var scope;
          scope = meta.scope(target);
          meta.attrs.forEach(function(attr) {
            return attr.extract(elem, scope, raw);
          });
          Array.from(elem.childNodes).forEach(function(child) {
            var match;
            match = meta.content.find(function(nodeDef) {
              return nodeDef.matches(child);
            });
            return match != null ? match.extract(child, scope, raw) : void 0;
          });
          return target;
        },
        fromDOM: function(elem, raw = false) {
          return exposed.extract(elem, {}, raw);
        },
        fromXML: function(str, raw = false) {
          return exposed.extract(parser.parseFromString(str).documentElement, {}, raw);
        },
        name: function() {
          return meta.name;
        },
        descriptor: function() {
          return meta.descriptor();
        },
        describe: function(obj) {
          if (obj != null) {
            meta.describe(obj);
            return obj;
          } else {
            obj = {};
            meta.describe(obj);
            return {
              type: 'object',
              keys: obj
            };
          }
        },
        relaxng: function(ctx) {
          var multiple, ref, required, wrap;
          required = (((ref = meta.content) != null ? ref.length : void 0) || 0) === 1 ? meta.content[0].isRequired() : meta.required;
          multiple = meta.multiple;
          wrap = (function() {
            switch (false) {
              case !(required && multiple):
                return ctx.element('oneOrMore').content;
              case !(!required && multiple):
                return ctx.element('zeroOrMore').content;
              case !(!required && !multiple):
                return ctx.element('optional').content;
            }
          })();
          wrap = wrap || identity;
          return wrap(ctx.element('element').attrs(ctx.attr('name').value(meta.name)).content(...meta.attrs.map(function(node) {
            return node.relaxng(ctx);
          }), ...meta.content.map(function(node) {
            return node.relaxng(ctx);
          }).filter(function(node) {
            return node != null;
          })));
        }
      };
      return exposed;
    };
  };

}).call(this);
